
#include "shared.h"

/*
  Copyright (C) 1986 Gary S. Brown. You may use this program, or
  code or tables extracted from it, as desired without restriction.

  Modified by Anders Danielsson, February 5, 1989 and March 10, 2006.
  Modified by IQ_132, June 11, 2007 (removed tables, use fairly 
  simple, fairly fast algorithm)

  This is also known as FCS-32 (as it is in PPP), described in
  RFC-1662 by William Allen Simpson, see RFC-1662 for references.
*/

unsigned int crc_tab(unsigned char a)
{
	unsigned int b = 0;

	if (a & 0x01) b ^= 0x77073096;
	if (a & 0x02) b ^= 0xEE0E612C;
	if (a & 0x04) b ^= 0x076DC419;
	if (a & 0x08) b ^= 0x0EDB8832;
	if (a & 0x10) b ^= 0x1DB71064;
	if (a & 0x20) b ^= 0x3B6E20C8;
	if (a & 0x40) b ^= 0x76DC4190;
	if (a & 0x80) b ^= 0xEDB88320;

	return b;
}

unsigned int crc32()
{
	int i;
	unsigned int crc = ~0;

	for (i = 0; i < nLen; i++)
	{
		crc = crc_tab(crc ^ src[i]) ^ (crc >> 8);
	}

	return ~crc;
}
