
/*
Copyright(C) 2007 yasu
http://hp.vector.co.jp/authors/VA013928/
http://www.usay.jp/
http://www.yasu.nu/
*/

#include "shared.h"

#define BIT_AT(n, i) ((n >> i) & 1)

void crypt(int crypt)
{
	int i, j, k;

	for (i = 0; i < nLen; i+= 512)
	{
		unsigned short key = (i / 512) ^ 0x484A;

		for (j = 0; j < 512; j++)
		{
			unsigned char xor1 = 0;
			if (key & 0x4000) xor1 |= 0x80;
			if (key & 0x1000) xor1 |= 0x40;
			if (key & 0x0800) xor1 |= 0x20;
			if (key & 0x0200) xor1 |= 0x10;
			if (key & 0x0080) xor1 |= 0x08;
			if (key & 0x0040) xor1 |= 0x04;
			if (key & 0x0002) xor1 |= 0x02;
			if (key & 0x0001) xor1 |= 0x01;

			if (crypt == 1)			// encrypt
				src[i+j] ^= xor1;

			unsigned int n = ((src[i+j] << 8) ^ key) << 16;
			unsigned int x = n;
			for (k = 1; k < 32; k++)
				x ^= n >> k;
			key = 0x0000;
			if (BIT_AT(x, 23)) key |= 0x8000;
			if (BIT_AT(n, 22)) key |= 0x4000;
			if (BIT_AT(n, 21)) key |= 0x2000;
			if (BIT_AT(n, 20)) key |= 0x1000;
			if (BIT_AT(n, 19)) key |= 0x0800;
			if (BIT_AT(n, 18)) key |= 0x0400;
			if (BIT_AT(n, 17) != BIT_AT(x, 31)) key |= 0x0200;
			if (BIT_AT(n, 16) != BIT_AT(x, 30)) key |= 0x0100;
			if (BIT_AT(n, 30) != BIT_AT(n, 29)) key |= 0x0080;
			if (BIT_AT(n, 29) != BIT_AT(n, 28)) key |= 0x0040;
			if (BIT_AT(n, 28) != BIT_AT(n, 27)) key |= 0x0020;
			if (BIT_AT(n, 27) != BIT_AT(n, 26)) key |= 0x0010;
			if (BIT_AT(n, 26) != BIT_AT(n, 25)) key |= 0x0008;
			if (BIT_AT(n, 25) != BIT_AT(n, 24)) key |= 0x0004;
			if (BIT_AT(n, 25) != BIT_AT(x, 26)) key |= 0x0002;
			if (BIT_AT(n, 24) != BIT_AT(x, 25)) key |= 0x0001;

			if (crypt == 0)			// decrypt
				src[i+j] ^= xor1;
		}
	}
}
