
#include "shared.h"

// Table of bytes to compare (in the search)
unsigned char cmp[0x10] = {
      /*0x94, 0xC7*/0xff, 0xeb, // BL ...
	0x80, 0x0b, 0xa0, 0xe1, // LSL R0 #17
	0xa0, 0x0b, 0xa0, 0xe1, // LSR R0 #17
	0,    0x0f, 0x50, 0xe3	// 0 is the byte to be patched
};

/*
E58D4058 STR R4, SP #58
E1C4C0B0 STRH R12, R5, #0
EAFFFD50 B 0200DB60
EBFFC794 BL 020000474
E1A00B80 MOV R0, R0, LSL #17
E1A00BA0 MOV Ro, Ro, LSR #17
E3500F7D CMP R0, #1F4

  DAA8:	75	7D // nop BNE
  E828:	75	7D // nop CMP
  E98C:	75	7D // nop BNE
  F560:	75	7D // nop CMP

	nop 0000A0E1

1310:	FD	FF
1404:	04	06
151C:	A1	A3
26B0:	CC	CE
2868:	46	44
2F50:	2D	2F
3C60:	05	07
3E38:	2D	2F
3F3C:	99	9B
4DF8:	28	2A
*/

void apply_patches()
{
	int i,j;

	// Patch the generic hardware checks

	if (flags)
	{
		for (i = 0, j = 0; i < nLen; i++)
		{
			if (memcmp (src + i, cmp, 0x0a) == 0 && memcmp (src + i + 0x0b, cmp + 0x0b, 0x03) == 0)
			{
				src[i + 0x0a] ^= flags;
				j++;
			}
		}
	
		// Generic hardware checks weren't found :S
	
		if (j == 0) {
			printf ("Hardware compatibility check not patched!\n");
			fail = 1;
			return;
		}
	
		// Patch the non-generic hardware checks (causes file loading to fail)
	
		for (i = 0, j = 0; i < 32; i++)
		{
			if (addresses[i]) {
				src[(nLen - 0x8400) + addresses[i]] ^= flags;
				j++;
			}
		}
	
		if (j == 0) {
			printf ("Hardware compatibility not patched!\n");
			fail = 1;
			return;
		}
	}

	// Remove save file size check

	if (~x_flags & 0x8000) return;

	unsigned char save_remove[8] = {
		0x40, 0x10, 0x8D, 0xE5, 0x02, 0x07, 0x52, 0xE3
	};

	for (i = 0, j = 0; i < nLen - 0x10; i++)
	{
		if (src[i + 0] == 0x02 && src[i + 0x01] == 0x07 && src[i + 0x03] == 0xE3 &&
			src[i + 0x06] == 0x00 && src[i + 0x0f] == 0xe5)
		{
			src[i + 0x07] = 0xEA;
			j++;
		}

		if (memcmp (src + i, save_remove, 8) == 0)
		{
			src[i + 0x08] = 0x02;
			src[i + 0x09] = 0x27;
			src[i + 0x0A] = 0xA0;
			src[i + 0x0B] = 0xE3;
			j++;
		}
	}

	if (j == 0)
	{
		printf ("Save file size check not removed!\n");
		fail = 1;
		return;
	}
}
